/**
 * @module vim-loader
 */
import { SceneBuilder } from './sceneBuilder';
import { BFast, VimHeader } from 'vim-format';
import { VimSettings } from '../vimSettings';
import { MeshBuilder } from './meshBuilder';
import { Vim } from '../vim';
/**
 * Loader for the Vim File format.
 * See https://github.com/vimaec/vim
 */
export declare class VimBuilder {
    readonly sceneBuilder: SceneBuilder;
    readonly meshBuilder: MeshBuilder;
    constructor();
    load(bfast: BFast, settings: VimSettings, source: string): Promise<Vim>;
    loadRemote(bfast: BFast, settings: VimSettings, source: string): Promise<Vim>;
    private getElementIds;
    static requestHeader(bfast: BFast): Promise<VimHeader>;
    private static requestG3d;
}
