import { ISimpleEvent } from 'ste-simple-events';
import { BFast, IProgressLogs, RemoteBuffer, Requester } from 'vim-format';
import { VimBuilder } from './vimBuilder';
import { VimSettings } from '../vimSettings';
import { Vim } from '../..';
export declare class VimRequest {
    loader: VimBuilder;
    url: string | undefined;
    settings: VimSettings;
    buffer: RemoteBuffer | ArrayBuffer;
    requester: Requester;
    bfast: BFast;
    vim: Vim;
    private _onProgress;
    get onProgress(): ISimpleEvent<IProgressLogs>;
    private _onLoaded;
    get onLoaded(): ISimpleEvent<Vim>;
    constructor(loader: VimBuilder, source: string | ArrayBuffer, settings: VimSettings);
    send(): Promise<Vim>;
    abort(): void;
}
