/**
 * @module vim-loader
 */
import * as THREE from 'three';
import { Vim } from '../../vim-loader/vim';
import { InstancedSubmesh } from './instancedSubmesh';
import { G3d, G3dMesh } from 'vim-format';
export declare class InstancedMesh {
    g3dMesh: G3dMesh | G3d;
    vim: Vim;
    mesh: THREE.InstancedMesh;
    bimInstances: ArrayLike<number>;
    meshInstances: ArrayLike<number>;
    boundingBox: THREE.Box3;
    boxes: THREE.Box3[];
    ignoreSceneMaterial: boolean;
    private _material;
    constructor(g3d: G3dMesh | G3d, mesh: THREE.InstancedMesh, instances: Array<number>);
    get merged(): boolean;
    /**
     * Returns submesh for given index.
     */
    getSubMesh(index: number): InstancedSubmesh;
    /**
     * Returns all submeshes for given index.
     */
    getSubmeshes(): InstancedSubmesh[];
    setMaterial(value: THREE.Material): void;
    private computeBoundingBoxes;
    private importBoundingBoxes;
    computeBoundingBox(boxes: THREE.Box3[]): THREE.Box3;
}
