/**
 * @module vim-loader
 */
import { Submesh } from '../mesh';
import { InstancedMesh } from './instancedMesh';
export declare class InstancedSubmesh {
    mesh: InstancedMesh;
    index: number;
    constructor(mesh: InstancedMesh, index: number);
    equals(other: Submesh): boolean;
    /**
     * Returns parent three mesh.
     */
    get three(): import("three").InstancedMesh<import("three").BufferGeometry, import("three").Material | import("three").Material[]>;
    /**
     * True if parent mesh is merged.
     */
    get merged(): boolean;
    /**
     * Returns vim instance associated with this submesh.
     */
    get instance(): number;
    /**
     * Returns bounding box for this submesh.
     */
    get boundingBox(): import("three").Box3;
    /**
     * Returns vim object for this submesh.
     */
    get object(): import("../object").Object;
}
