/**
 * @module vim-loader
 */
import { Scene } from '../../vim-loader/scene';
import { G3dMaterial, G3d } from 'vim-format';
import { G3dSubset } from './g3dSubset';
/**
 * Mesh factory to load a standard vim using the progressive pipeline.
 */
export declare class VimMeshFactory {
    readonly g3d: G3d;
    private _materials;
    private _instancedFactory;
    private _scene;
    constructor(g3d: G3d, materials: G3dMaterial, scene: Scene);
    /**
     * Adds all instances from subset to the scene
     */
    add(subset: G3dSubset): void;
    private addMergedMesh;
    private createMergedMesh;
    private addInstancedMeshes;
}
