/**
 * @module vim-loader
 */
import { G3dMaterial, RemoteVimx, VimHeader, G3dScene } from 'vim-format';
/**
 * Interface to interact with a vimx
 */
export declare class Vimx {
    private readonly vimx;
    readonly scene: G3dScene;
    readonly materials: G3dMaterial;
    readonly header: VimHeader;
    static fromRemote(vimx: RemoteVimx, downloadMeshes: boolean): Promise<Vimx>;
    private constructor();
    getMesh(mesh: number): Promise<import("vim-format").G3dMesh>;
    abort(): void;
}
