/**
 * @module viw-webgl-viewer/camera
 */
import * as THREE from 'three';
import { Camera } from './camera';
import { Object } from '../../vim-loader/object';
import { CameraMovementSnap } from './cameraMovementSnap';
import { CameraMovement } from './cameraMovement';
export declare class CameraLerp extends CameraMovement {
    _movement: CameraMovementSnap;
    _clock: THREE.Clock;
    onProgress: ((progress: number) => void) | undefined;
    _duration: number;
    constructor(camera: Camera, movement: CameraMovementSnap);
    init(duration: number): void;
    cancel(): void;
    animate(): void;
    easeOutCubic(x: number): number;
    update(): void;
    move3(vector: THREE.Vector3): void;
    rotate(angle: THREE.Vector2): void;
    zoom(amount: number): void;
    setDistance(dist: number): void;
    orbit(angle: THREE.Vector2): void;
    target(target: Object | THREE.Vector3): void;
    reset(): void;
    set(position: THREE.Vector3, target?: THREE.Vector3): void;
}
