import { Viewer } from '../../viewer';
import * as THREE from 'three';
import { GizmoMarker } from './gizmoMarker';
/**
 * API for adding and managing sprite markers in the scene.
 */
export declare class GizmoMarkers {
    private _viewer;
    private _markers;
    private _mesh;
    constructor(viewer: Viewer);
    getMarkerFromIndex(index: number): GizmoMarker;
    private createMesh;
    private resizeMesh;
    /**
     * Adds a sprite marker at the specified position.
     * @param {THREE.Vector3} position - The position at which to add the marker.
     */
    add(position: THREE.Vector3): GizmoMarker;
    /**
     * Removes the specified marker from the scene.
     * @param {GizmoMarker} marker - The marker to remove.
     */
    remove(marker: GizmoMarker): void;
    /**
     * Removes all markers from the scene.
     */
    clear(): void;
}
