/**
 @module viw-webgl-viewer/gizmos/measure
*/
import * as THREE from 'three';
import { Viewer } from '../../viewer';
/**
 * Reprents all graphical elements associated with a measure.
 */
export declare class MeasureGizmo {
    private _viewer;
    private _startMarker;
    private _endMarker;
    private _line;
    private _lineX;
    private _lineY;
    private _lineZ;
    private _group;
    private _label;
    private _html;
    private _animId;
    constructor(viewer: Viewer);
    private _animate;
    private screenDist;
    /**
     * Sets up a new measure
     */
    start(start: THREE.Vector3): void;
    /**
     * Hides existing measure.
     */
    hide(): void;
    /**
     * Updates current measure
     */
    update(start: THREE.Vector3, pos: THREE.Vector3): void;
    /**
     * Finishes current measure.
     */
    finish(start: THREE.Vector3, end: THREE.Vector3): boolean;
    /**
     * Disposes all resources.
     */
    dispose(): void;
}
