/**
 @module viw-webgl-viewer/gizmos/measure
*/
/**
 * Different styles of measure display.
 */
export type MeasureStyle = 'all' | 'Dist' | 'X' | 'Y' | 'Z';
/**
 * Structure of the html element used for measure.
 */
export type MeasureElement = {
    div: HTMLElement;
    value: HTMLTableCellElement | undefined;
    values: {
        dist: HTMLTableCellElement | undefined;
        x: HTMLTableCellElement | undefined;
        y: HTMLTableCellElement | undefined;
        z: HTMLTableCellElement | undefined;
    };
};
/**
 * Creates a html structure for measure value overlays
 * It either creates a single rows or all rows depending on style
 * Structure is a Table of Label:Value
 */
export declare function createMeasureElement(style: MeasureStyle): MeasureElement;
