/**
 * @module viw-webgl-viewer/gizmos/sectionBox
 */
import * as THREE from 'three';
/**
 * Defines the thin outline on the edges of the section box.
 */
export declare class BoxOutline extends THREE.LineSegments {
    constructor();
    /**
     * Resize the outline to the given box.
     */
    fitBox(box: THREE.Box3): void;
    /**
     * Disposes of all resources.
     */
    dispose(): void;
}
/**
 * Defines the box mesh for the section box.
 */
export declare class BoxMesh extends THREE.Mesh {
    constructor();
    /**
     * Resize the mesh to the given box.
     */
    fitBox(box: THREE.Box3): void;
    /**
     * Disposes of all resources.
     */
    dispose(): void;
}
/**
 * Defines the face highlight on hover for the section box.
 */
export declare class BoxHighlight extends THREE.Mesh {
    constructor();
    /**
     * Sets the face to highlight
     * @param normal a direction vector from theses options (X,-X, Y,-Y, Z,-Z)
     */
    highlight(box: THREE.Box3, normal: THREE.Vector3): void;
    /**
     * Disposes all resources.
     */
    dispose(): void;
}
