/**
 * @module viw-webgl-viewer/inputs
 */
import { InputHandler } from './inputHandler';
import { Viewer } from '../viewer';
/**
 * Manages user touch inputs.
 */
export declare class TouchHandler extends InputHandler {
    private readonly TAP_DURATION_MS;
    private readonly DOUBLE_TAP_DELAY_MS;
    private readonly TAP_MAX_MOVE_PIXEL;
    private readonly ZOOM_SPEED;
    private readonly MOVE_SPEED;
    /**
     * Speed factor for rotation movements
     */
    rotateSpeed: number;
    /**
    * Speed factor for orbit movements
    */
    orbitSpeed: number;
    constructor(viewer: Viewer);
    private get camera();
    private get viewport();
    private _touch;
    private _touch1;
    private _touch2;
    private _touchStartTime;
    private _lastTapMs;
    private _touchStart;
    protected addListeners(): void;
    reset: () => void;
    private onTap;
    private onTouchStart;
    private toRotation;
    private onDrag;
    private onDoubleDrag;
    private onPinchOrSpread;
    private onTouchMove;
    private onTouchEnd;
    private isSingleTouch;
    private touchToVector;
    private average;
}
