/**
 * @module viw-webgl-viewer/rendering
 */
import * as THREE from 'three';
import { Pass } from 'three/examples/jsm/postprocessing/Pass.js';
import { OutlineMaterial } from '../../vim-loader/materials/outlineMaterial';
/**
 * Edge detection pass on the current readbuffer depth texture.
 */
export declare class OutlinePass extends Pass {
    private _fsQuad;
    material: OutlineMaterial;
    constructor(sceneBuffer: THREE.Texture, camera: THREE.PerspectiveCamera | THREE.OrthographicCamera, material?: OutlineMaterial);
    setSize(width: number, height: number): void;
    get camera(): THREE.PerspectiveCamera | THREE.OrthographicCamera;
    set camera(value: THREE.PerspectiveCamera | THREE.OrthographicCamera);
    dispose(): void;
    render(renderer: THREE.WebGLRenderer, writeBuffer: THREE.WebGLRenderTarget, readBuffer: THREE.WebGLRenderTarget): void;
}
