/**
 * @module viw-webgl-viewer/rendering
 */
import * as THREE from 'three';
import { ViewerMaterials } from '../../vim-loader/materials/viewerMaterials';
import { Renderer } from './renderer';
/**
 * Manages a section box from renderer clipping planes
 */
export declare class RenderingSection {
    private _renderer;
    private _materials;
    private _active;
    /**
     * Current section box. To update the box use fitbox.
     */
    readonly box: THREE.Box3;
    private maxX;
    private minX;
    private maxY;
    private minY;
    private maxZ;
    private minZ;
    private planes;
    constructor(renderer: Renderer, materials: ViewerMaterials);
    /**
     * Resizes the section box to match the dimensions of the provided bounding box.
     * @param box The bounding box to match the section box to.
     */
    fitBox(box: THREE.Box3): void;
    /**
     * Determines whether objecets outside the section box will be culled or not.
     */
    set active(value: boolean);
    get active(): boolean;
}
